package no.nav.eia.dynaregler.helpers;

import java.util.ArrayList;
import java.util.Date;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

import no.nav.eia.dynaregler.element.RegelElement;

/**
 * 
 * @author Florian van Eizenga (E140074)
 * Denne klassen er en sttteklasse kun for  behandle "naturlige regelsprk" til obligatoriske felt og sprsml.  
 *
 */

public class NaturalRuleExpressionEvaluator {
		
	private ScriptEngine engine = null;
	
	protected NaturalRuleExpressionEvaluator() {
		
		engine = new ScriptEngineManager().getEngineByName("JavaScript");
	}
	
	public Boolean evaluate(String expression, ArrayList<RegelElement> gyldigeRegler) {
		
		Boolean evalResult = false;
		
		try {
			
			expression = convertToJavaScript(expression, gyldigeRegler);
			Object result = engine.eval(expression);
			
			if (result instanceof Boolean) {
				
				evalResult = (Boolean) result;
			}
			
		} catch(ScriptException e) {
			
			e.printStackTrace();
		}
		
		return evalResult;
	}
	
	private String convertToJavaScript(String booleanExpression, ArrayList<RegelElement> gyldigeRegler) {
		
		for (RegelElement regel : gyldigeRegler) {
			
			if (booleanExpression.contains(regel.getRegelNavn())) {
				
				booleanExpression = booleanExpression.replaceAll(regel.getRegelNavn(), regel.getRule().toString());
			}
		}
		
		booleanExpression = booleanExpression.replaceAll(" OG ", " && ").replaceAll(" ELLER ", " || ").replaceAll("IKKE", "!");
		
		return booleanExpression;
	}
}
