package no.nav.eia.dynaregler.element;

import java.util.ArrayList;
import java.util.List;

import org.jdom.Element;

public class RegelElement {
	
	private String regelNavn;
	private String beskrivelse;
	private ArrayList<ParameterElement> parameterList;
	private Boolean rule;
	
	public RegelElement() {
		super();
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((regelNavn == null) ? 0 : regelNavn.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object other) {
		
		if (this == other) return true;
		
		if (!(other instanceof RegelElement)) return false;
		
		RegelElement otherRegelElement = (RegelElement) other;
		
		return (this.getRegelNavn().equals(otherRegelElement.getRegelNavn()));
	}
		
	public String getRegelNavn() {
		return regelNavn;
	}

	public void setRegelNavn(String regelNavn) {
		this.regelNavn = regelNavn;
	}

	public String getBeskrivelse() {
		return beskrivelse;
	}

	public void setBeskrivelse(String beskrivelse) {
		this.beskrivelse = beskrivelse;
	}

	public ArrayList<ParameterElement> getParameterList() {
		return this.parameterList;
	}

	public void setParameterList(ArrayList<ParameterElement> parameterList) {
		this.parameterList = parameterList;
	}
	
	public Boolean getRule() {
		return rule;
	}

	public void setRule(Boolean rule) {
		this.rule = rule;
	}

	public RegelElement newRegelElement(Element e) throws Exception {
		
		RegelElement r = null;
		ParameterElement pe = null;
		ArrayList<ParameterElement> parameterListLocal = new ArrayList<ParameterElement>();
		
		if(e.getName().equals("DynaRegel")) {
			
			r = new RegelElement();
			r.setRegelNavn(e.getAttributeValue("navn"));
			r.setBeskrivelse(e.getChildText("Beskrivelse"));
			r.setRule(false);
			
			@SuppressWarnings("unchecked")
			List<Element> children = (e != null ? e.getChildren("Parameter") : new ArrayList<Element>());
			
			for (Element child : children) {
					
				pe = new ParameterElement();
				pe.setDiagGruppeICPC2(((Element) child).getChildText("DiagGruppe_ICPC2"));
				pe.setDiagGruppeICD10(((Element) child).getChildText("DiagGruppe_ICD10"));
				pe.setTidsGruppe(((Element) child).getChildText("Tidsgruppe"));
				pe.setKjonn(((Element) child).getChildText("Kjonn"));
				pe.setAldersGruppe(((Element) child).getChildText("AldersGruppe"));
				parameterListLocal.add(pe);
			}
			
			r.setParameterList(parameterListLocal);
	
		} else {
			throw new Exception("newRegelElement:Ignore element named: " + e.getName());
		}
		return r;	
	}	
}