package no.nav.eia.dynaregler.element;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.jdom.Element;

public class SykmeldingParameterElement {

	private HovedDiagnoseElement hovedDiagnose;
	private String kjonn;
	private String alder;
	private Date syketilfelleStartDato;
	private Date sykmeldingFOMDato;
	private Date sykmeldingTOMDato;
	
	private static SimpleDateFormat date = new SimpleDateFormat("yyyy-MM-dd");
	
	public SykmeldingParameterElement() {
		super();
	}

	public HovedDiagnoseElement getHovedDiagnose() {
		return hovedDiagnose;
	}

	public void setHovedDiagnose(HovedDiagnoseElement hovedDiagnose) {
		this.hovedDiagnose = hovedDiagnose;
	}
	
	public String getKjonn() {
		return kjonn;
	}

	public void setKjonn(String kjonn) {
		this.kjonn = kjonn;
	}

	public String getAlder() {
		return alder;
	}

	public void setAlder(String alder) {
		this.alder = alder;
	}

	public Date getSyketilfelleStartDato() {
		return syketilfelleStartDato;
	}

	public void setSyketilfelleStartDato(Date syketilfelleStartDato) {
		this.syketilfelleStartDato = syketilfelleStartDato;
	}

	public Date getSykmeldingFOMDato() {
		return sykmeldingFOMDato;
	}

	public void setSykmeldingFOMDato(Date sykmeldingFOMDato) {
		this.sykmeldingFOMDato = sykmeldingFOMDato;
	}

	public Date getSykmeldingTOMDato() {
		return sykmeldingTOMDato;
	}

	public void setSykmeldingTOMDato(Date sykmeldingTOMDato) {
		this.sykmeldingTOMDato = sykmeldingTOMDato;
	}
	
	public SykmeldingParameterElement newSykmeldingParameterElement(Element e) throws Exception {
		
		SykmeldingParameterElement sykmeldingParameter = null;
		HovedDiagnoseElement hovedDiagnoseElement = null;
		
		if(e.getName().equals("SykmeldingParameter")) {
			
			hovedDiagnoseElement = new HovedDiagnoseElement();
			hovedDiagnoseElement.setKodeSystemS(e.getChild("HovedDiagnose").getChildText("S"));
			hovedDiagnoseElement.setKodeV((e.getChild("HovedDiagnose").getChildText("V")));
			hovedDiagnoseElement.setTekstDN((e.getChild("HovedDiagnose").getChildText("DN")));
			
			sykmeldingParameter = new SykmeldingParameterElement();
			sykmeldingParameter.setHovedDiagnose(hovedDiagnoseElement);
			sykmeldingParameter.setKjonn(e.getChildText("Kjonn"));
			sykmeldingParameter.setAlder(e.getChildText("Alder"));
			sykmeldingParameter.setSyketilfelleStartDato(date.parse(e.getChildText("SyketilfelleStartDato")));
			sykmeldingParameter.setSykmeldingFOMDato(date.parse(e.getChildText("SykmeldingFOMDato")));
			sykmeldingParameter.setSykmeldingTOMDato(date.parse(e.getChildText("SykmeldingTOMDato")));
			
		}
		
		return sykmeldingParameter;
	}
	 
}